
AttackGroupSize =
{
	easy = 7,
	normal = 8,
	hard = 9
}

AttackDelays =
{
	easy = { DateTime.Minutes(2), DateTime.Seconds(10) },
	normal = { DateTime.Minutes(1), DateTime.Seconds(15) },
	hard = { DateTime.Seconds(40), DateTime.Seconds(30) }
}

InitialProductionDelay =
{
	easy = DateTime.Seconds(4000),
	normal = DateTime.Seconds(2000),
	hard = DateTime.Seconds(500)
}

HarkonnenInfantryTypes = { "light_inf", "light_inf", "light_inf", "trooper", "trooper" }
HarkonnenTankType = { "combat_tank_h" }

-- Overwrite the template function because of the message
SendAttack = function(owner, size)
	if Attacking[owner] then
		return
	end
	Attacking[owner] = true
	HoldProduction[owner] = true

	local units = SetupAttackGroup(owner, size)
	Utils.Do(units, IdleHunt)

	if #units > 0 then
		Media.DisplayMessage("Harkonnen units approaching!", "Fremen Leader")
	end

	Trigger.OnAllRemovedFromWorld(units, function()
		Attacking[owner] = false
		HoldProduction[owner] = false
	end)
end

InitAIUnits = function()
	IdlingUnits[Harkonnen] = Reinforcements.Reinforce(Harkonnen, InitialHarkonnenReinforcements, HarkonnenPaths[1])

	DefendAndRepairBase(Harkonnen, HarkonnenBase, 0.75, AttackGroupSize[Difficulty])
end

ActivateAI = function()
	LastHarvesterEaten[Harkonnen] = true
	InitAIUnits()
	FremenProduction()

	local delay = function() return Utils.RandomInteger(AttackDelays[Difficulty][1], AttackDelays[Difficulty][2] + 1) end
	local infantryToBuild = function() return { Utils.Random(HarkonnenInfantryTypes) } end
	local tanksToBuild = function() return HarkonnenTankType end
	local attackThresholdSize = AttackGroupSize[Difficulty] * 2.5

	ProduceUnits(Harkonnen, HarkonnenBarracks, delay, infantryToBuild, AttackGroupSize[Difficulty], attackThresholdSize)
	ProduceUnits(Harkonnen, HarkonnenHeavyFact, delay, tanksToBuild, AttackGroupSize[Difficulty], attackThresholdSize)
end
